    001/* ===========================================================
    002 * JFreeChart : a free chart library for the Java(tm) platform
    003 * ===========================================================
    004 *
    005 * (C) Copyright 2000-2011, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jfreechart/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Oracle and Java are registered trademarks of Oracle and/or its affiliates.
    025 * Other names may be trademarks of their respective owners.]
    026 *
    027 * -------------------
    028 * CategoryAnchor.java
    029 * -------------------
    030 * (C) Copyright 2003-2008, by Object Refinery Limited.
    031 *
    032 * Original Author:  David Gilbert (for Object Refinery Limited);
    033 * Contributor(s):   -;
    034 *
    035 * Changes:
    036 * --------
    037 * 04-Jul-2003 : Version 1 (DG);
    038 *
    039 */
    040
    041package org.jfree.chart.axis;
    042
    043import java.io.ObjectStreamException;
    044import java.io.Serializable;
    045
    046/**
    047 * Used to indicate one of three positions within a category:
    048 * <code>START</code>, <code>MIDDLE</code> and <code>END</code>.
    049 */
    050public final class CategoryAnchor implements Serializable {
    051
    052    /** For serialization. */
    053    private static final long serialVersionUID = -2604142742210173810L;
    054
    055    /** Start of period. */
    056    public static final CategoryAnchor START
    057        = new CategoryAnchor("CategoryAnchor.START");
    058
    059    /** Middle of period. */
    060    public static final CategoryAnchor MIDDLE
    061        = new CategoryAnchor("CategoryAnchor.MIDDLE");
    062
    063    /** End of period. */
    064    public static final CategoryAnchor END
    065        = new CategoryAnchor("CategoryAnchor.END");
    066
    067    /** The name. */
    068    private String name;
    069
    070    /**
    071     * Private constructor.
    072     *
    073     * @param name  the name.
    074     */
    075    private CategoryAnchor(String name) {
    076        this.name = name;
    077    }
    078
    079    /**
    080     * Returns a string representing the object.
    081     *
    082     * @return The string.
    083     */
    084    public String toString() {
    085        return this.name;
    086    }
    087
    088    /**
    089     * Returns <code>true</code> if this object is equal to the specified
    090     * object, and <code>false</code> otherwise.
    091     *
    092     * @param obj  the other object.
    093     *
    094     * @return A boolean.
    095     */
    096    public boolean equals(Object obj) {
    097
    098        if (this == obj) {
    099            return true;
    100        }
    101        if (!(obj instanceof CategoryAnchor)) {
    102            return false;
    103        }
    104        CategoryAnchor position = (CategoryAnchor) obj;
    105        if (!this.name.equals(position.toString())) {
    106            return false;
    107        }
    108        return true;
    109
    110    }
    111
    112    /**
    113     * Ensures that serialization returns the unique instances.
    114     *
    115     * @return The object.
    116     *
    117     * @throws ObjectStreamException if there is a problem.
    118     */
    119    private Object readResolve() throws ObjectStreamException {
    120        if (this.equals(CategoryAnchor.START)) {
    121            return CategoryAnchor.START;
    122        }
    123        else if (this.equals(CategoryAnchor.MIDDLE)) {
    124            return CategoryAnchor.MIDDLE;
    125        }
    126        else if (this.equals(CategoryAnchor.END)) {
    127            return CategoryAnchor.END;
    128        }
    129        return null;
    130    }
    131
    132}